{=====================================================================
 Pdxrbld - Paradox tables repair utility  Copyright 1998 by
 Roman Krejci-RKS, Pujmanove 1552, 140 00 Prague 4, Czech Republic
 http://www.rksolution.cz, EMail INFO@rksolution.cz
 =====================================================================}

unit Main;
{$I ..\PDXRBLD.INC}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ShellAPI,
  StdCtrls, DB, DBTables, BDE, ExtCtrls, ComCtrls, FileCtrl, RKSIni, Registry, RegStr,
  TUtil32, PxHeader, Rbld1, Translat;

Const
  WM_RUNCMDLINE = WM_USER + 2; 

type
  TMainForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ButtonStart: TButton;
    TabSheet2: TTabSheet;
    ListView1: TListView;
    ProgressDatabase: TProgressBar;
    LabelInfo: TLabel;
    LabelTablename: TLabel;
    LabelWhatDoing: TLabel;
    ButtonStop: TButton;
    ButtonClose: TButton;
    Panel1: TPanel;
    RadioAlias: TRadioGroup;
    Label1: TLabel;
    AliasCombo: TComboBox;
    Label2: TLabel;
    ButtonBrowse: TButton;
    CheckDoPack: TCheckBox;
    DirectoryCombo: TComboBox;
    tableCombo: TComboBox;
    Label3: TLabel;
    CheckDoLog: TCheckBox;
    ProgressTable: TProgressBar;
    rgRebuildScope: TRadioGroup;
    Bevel1: TBevel;
    Image1: TImage;
    ButtonViewLog: TButton;
    LabelDetails: TLabel;
    CheckSkipVerify: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure ButtonStartClick(Sender: TObject);
    procedure ButtonBrowseClick(Sender: TObject);
    procedure RadioAliasClick(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure tableComboEnter(Sender: TObject);
    procedure AliasComboChange(Sender: TObject);
    procedure DirectoryComboChange(Sender: TObject);
    procedure ButtonViewLogClick(Sender: TObject);
    procedure rgRebuildScopeClick(Sender: TObject);
  private
    { Private declarations }
    procedure AddListViewMessage(const atbl,amessage: string; aProcess: TRebuildProcess);
  public
    procedure WMRunCmdLine(Var Message:tMessage); message wm_runcmdline;
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses LowStuff,DirDlg;

{$R *.DFM}
{$I ..\main.inc}

{ ---------  MAINFORM ----------- }

procedure TMainForm.AddListViewMessage(const atbl,amessage: string; aProcess: TRebuildProcess);
begin
  with ListView1.Items.Add do begin
    caption := aTbl;
    subitems.add(amessage);
  end;
  tblToList := ''; { table name will be written only once to the listview}
  if not pagecontrol1.pages[1].tabVisible then begin
    With ListView1 do begin
      Columns[0].caption := LoadStr(dfm_ListView1Column0Caption);
      Columns[1].caption := LoadStr(dfm_ListView1Column1Caption);
      Columns[0].width := 100;
      Columns[1].width := ColumnTextWidth;
    end;
    pagecontrol1.pages[1].tabVisible := True;
    UseExitCode := - 1;  // There's an error message so set Exit code to -1
  end;
  if aProcess <> cpPack then Inc(LastTblErrCount);
  if LogToFile then
    if CompareText(ExtractFileExt(LastTbl),'.DB') = 0 then
      Writeln(LogFile,LoadStr(msg_TblnamePrefix),
                      Padright(LastTbl,TblnamePadLen),
                      LoadStr(msg_MsgSeparator),
                      amessage)
    else
      Writeln(LogFile,LoadStr(msg_IndexnamePrefix),
                      Padright(LastTbl,TblnamePadLen),
                      LoadStr(msg_MsgSeparator),
                      amessage)
end;


procedure TMainForm.FormCreate(Sender: TObject);
begin
  TMainFormFormCreate(Sender);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  TMainFormFormDestroy(Sender);
end;

procedure TMainForm.WMRunCmdLine(Var Message:tMessage);
begin
  TMainFormWMRunCmdLine(Message);
end;

procedure TMainForm.ButtonStartClick(Sender: TObject);
begin 
  TMainFormButtonStartClick(Sender);
end;

procedure TMainForm.ButtonStopClick(Sender: TObject);
begin
  TMainFormButtonStopClick(Sender);
end;

procedure TMainForm.ButtonCloseClick(Sender: TObject);
begin
  TMainFormButtonCloseClick(Sender);
end;

procedure TMainForm.ButtonViewLogClick(Sender: TObject);
begin
  TMainFormButtonViewLogClick(Sender);
end;

procedure TMainForm.ButtonBrowseClick(Sender: TObject);
begin
  TMainFormButtonBrowseClick(Sender);
end;

procedure TMainForm.RadioAliasClick(Sender: TObject);
begin
  TMainFormRadioAliasClick(Sender);
end;

procedure TMainForm.tableComboEnter(Sender: TObject);
begin
  TMainFormtableComboEnter(Sender);
end;

procedure TMainForm.AliasComboChange(Sender: TObject);
begin
  TMainFormAliasComboChange(Sender);
end;

procedure TMainForm.DirectoryComboChange(Sender: TObject);
begin
  TMainFormDirectoryComboChange(Sender);
end;


procedure TMainForm.rgRebuildScopeClick(Sender: TObject);
begin
  TMainFormrgRebuildScopeClick(Sender);
end;

initialization
  Initialize;

Finalization
  ExitCode := UseExitCode;

end.




